.TH "siggen::ThreadManagerPowerSaver" 3 "Wed Oct 9 2019" "Version 1.0" "SigGen" \" -*- nroff -*-
.ad l
.nh
.SH NAME
siggen::ThreadManagerPowerSaver \- default thread manager using mutexes and condition variables  

.SH SYNOPSIS
.br
.PP
.PP
\fC#include <ThreadManagerPowerSaver\&.h>\fP
.PP
Inherits \fBsiggen::ThreadManager\fP\&.
.SS "Public Member Functions"

.in +1c
.ti -1c
.RI "\fBThreadManagerPowerSaver\fP (\fBData\fP &&data)"
.br
.RI "spawns data\&.m_ThreadCount threads to do the work "
.ti -1c
.RI "virtual void \fBProcessToBuffer\fP (std::vector< char > &result) override"
.br
.RI "reads a block of data from input file, and enqueues the data for further processing by threads "
.in -1c
.SS "Protected Member Functions"

.in +1c
.ti -1c
.RI "void \fBConsumerThread\fP (size_t threadIndex)"
.br
.RI "basic loop for spawned consumer threads "
.in -1c
.SS "Additional Inherited Members"
.SH "Detailed Description"
.PP 
default thread manager using mutexes and condition variables 
.PP
Definition at line 16 of file ThreadManagerPowerSaver\&.h\&.
.SH "Member Function Documentation"
.PP 
.SS "void siggen::ThreadManagerPowerSaver::ConsumerThread (size_t threadIndex)\fC [protected]\fP"

.PP
basic loop for spawned consumer threads Consumer thread tries to dequeue (block, data) in order to calculate to hash on dequeued block\&. If there is no data, it sleeps on condition variable\&. Otherwise it calculates the digest, and posts it to m_Signatures 
.PP
Definition at line 28 of file ThreadManagerPowerSaver\&.cpp\&.
.SS "void siggen::ThreadManagerPowerSaver::ProcessToBuffer (std::vector< char > & result)\fC [override]\fP, \fC [virtual]\fP"

.PP
reads a block of data from input file, and enqueues the data for further processing by threads 
.PP
\fBParameters\fP
.RS 4
\fIresult\fP buffer with resulting signatures
.RE
.PP
The block of data is swapped with empty block from an idle thread and reading continues\&. At the end of the file it waits for all the threads to complete work, then writes resulting data to the buffer and terminates\&. 
.PP
Implements \fBsiggen::ThreadManager\fP\&.
.PP
Definition at line 64 of file ThreadManagerPowerSaver\&.cpp\&.

.SH "Author"
.PP 
Generated automatically by Doxygen for SigGen from the source code\&.
